#include <FunctionHook/Hook.h>
#include <sys/mman.h>
#include <csignal>
#include <cstring>

using namespace FunctionHooking;
void Detour::RemoveHook() {

    //Make the target memory page writable.
    mprotect((void*)((uintptr_t)source & ~(sysconf(_SC_PAGE_SIZE)-1)), sysconf(_SC_PAGE_SIZE), PROT_READ|PROT_WRITE|PROT_EXEC);

    //Replace our hook with the bytes that were originally there.
    memcpy(source, overwritten_bytes.data(), overwritten_bytes.size());

    //Make the memory page non-writable again.
    mprotect((void*)((uintptr_t)source & ~(sysconf(_SC_PAGE_SIZE)-1)), sysconf(_SC_PAGE_SIZE), PROT_READ|PROT_EXEC);
}

Detour::Detour(void* source_address, void* destination_address) : source(source_address), destination(destination_address)  {
    CreateHook(source, destination);
}

bool FunctionHooking::Detour::Valid() {
    if (source == nullptr || destination == nullptr)
        return false;

    if (hook_bytes.empty() || overwritten_bytes.empty())
        return false;

    std::vector<uint8_t> current_data(hook_bytes.size());
    memcpy(current_data.data(), source, current_data.size());

    return current_data == hook_bytes;
}

Detour::~Detour() {
    if (Valid())
        RemoveHook();
}
